]> git.ipfire.org Git - thirdparty/git.git/blame - git-stash.sh
send-email: use catfile() to concatenate files
[thirdparty/git.git] / git-stash.sh
CommitLineData
f2c66ed1
NS
1#!/bin/sh
2# Copyright (c) 2007, Nanako Shiraishi
3
a5ab00c5
SB
4dashless=$(basename "$0" | sed -e 's/-/ /')
5USAGE="list [<options>]
fcdd0e92
SB
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
a5ab00c5 9 or: $dashless branch <branchname> [<stash>]
dc89689e 10 or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
a5ab00c5 11 or: $dashless clear"
f2c66ed1 12
3cd2491a 13SUBDIRECTORY_OK=Yes
8f321a39 14OPTIONS_SPEC=
f2c66ed1
NS
15. git-sh-setup
16require_work_tree
ceff079b 17cd_to_toplevel
f2c66ed1
NS
18
19TMP="$GIT_DIR/.git-stash.$$"
20trap 'rm -f "$TMP-*"' 0
21
22ref_stash=refs/stash
23
dda1f2a5
TR
24if git config --get-colorbool color.interactive; then
25 help_color="$(git config --get-color color.interactive.help 'red bold')"
26 reset_color="$(git config --get-color '' reset)"
27else
28 help_color=
29 reset_color=
30fi
31
f2c66ed1 32no_changes () {
6848d58c
JS
33 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
34 git diff-files --quiet --ignore-submodules
f2c66ed1
NS
35}
36
37clear_stash () {
3023dc69
JH
38 if test $# != 0
39 then
40 die "git stash clear with parameters is unimplemented"
41 fi
0e32126f 42 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
7ab3cc70 43 then
a9ee9bf9 44 git update-ref -d $ref_stash $current
7ab3cc70 45 fi
f2c66ed1
NS
46}
47
bc9e7399 48create_stash () {
9f62e18a
JH
49 stash_msg="$1"
50
1eff26c0 51 git update-index -q --refresh
f2c66ed1
NS
52 if no_changes
53 then
f2c66ed1
NS
54 exit 0
55 fi
f12e925a 56
f2c66ed1 57 # state of the base commit
5be60078 58 if b_commit=$(git rev-parse --verify HEAD)
f2c66ed1 59 then
b0e621ad 60 head=$(git rev-list --oneline -n 1 HEAD --)
f2c66ed1
NS
61 else
62 die "You do not have the initial commit yet"
63 fi
64
5be60078 65 if branch=$(git symbolic-ref -q HEAD)
f2c66ed1
NS
66 then
67 branch=${branch#refs/heads/}
68 else
69 branch='(no branch)'
70 fi
71 msg=$(printf '%s: %s' "$branch" "$head")
72
73 # state of the index
5be60078 74 i_tree=$(git write-tree) &&
6143fa2c 75 i_commit=$(printf 'index on %s\n' "$msg" |
5be60078 76 git commit-tree $i_tree -p $b_commit) ||
f2c66ed1
NS
77 die "Cannot save the current index state"
78
dda1f2a5
TR
79 if test -z "$patch_mode"
80 then
81
82 # state of the working tree
83 w_tree=$( (
84 rm -f "$TMP-index" &&
85 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
86 GIT_INDEX_FILE="$TMP-index" &&
87 export GIT_INDEX_FILE &&
88 git read-tree -m $i_tree &&
7aa5d43c 89 git diff --name-only -z HEAD | git update-index -z --add --remove --stdin &&
dda1f2a5
TR
90 git write-tree &&
91 rm -f "$TMP-index"
92 ) ) ||
93 die "Cannot save the current worktree state"
94
95 else
96
b24f56d6 97 rm -f "$TMP-index" &&
dda1f2a5
TR
98 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
99
100 # find out what the user wants
101 GIT_INDEX_FILE="$TMP-index" \
102 git add--interactive --patch=stash -- &&
103
104 # state of the working tree
105 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
f2c66ed1
NS
106 die "Cannot save the current worktree state"
107
dda1f2a5
TR
108 git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
109 test -s "$TMP-patch" ||
110 die "No changes selected"
111
112 rm -f "$TMP-index" ||
113 die "Cannot remove temporary index (can't happen)"
114
115 fi
116
f2c66ed1 117 # create the stash
9f62e18a
JH
118 if test -z "$stash_msg"
119 then
120 stash_msg=$(printf 'WIP on %s' "$msg")
121 else
122 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
123 fi
124 w_commit=$(printf '%s\n' "$stash_msg" |
5be60078 125 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
f2c66ed1 126 die "Cannot record working tree state"
bc9e7399 127}
f2c66ed1 128
bc9e7399 129save_stash () {
7bedebca 130 keep_index=
dda1f2a5 131 patch_mode=
fcdd0e92
SB
132 while test $# != 0
133 do
134 case "$1" in
ea41cfc4 135 -k|--keep-index)
fcdd0e92
SB
136 keep_index=t
137 ;;
dda1f2a5
TR
138 --no-keep-index)
139 keep_index=
140 ;;
141 -p|--patch)
142 patch_mode=t
fcdd0e92
SB
143 keep_index=t
144 ;;
145 -q|--quiet)
146 GIT_QUIET=t
147 ;;
3c2eb80f
MM
148 --)
149 shift
150 break
151 ;;
152 -*)
153 echo "error: unknown option for 'stash save': $1"
5d005922 154 echo " To provide a message, use git stash save -- '$1'"
3c2eb80f
MM
155 usage
156 ;;
fcdd0e92
SB
157 *)
158 break
159 ;;
160 esac
7bedebca 161 shift
fcdd0e92 162 done
7bedebca 163
47629dcf 164 stash_msg="$*"
bc9e7399 165
1eff26c0 166 git update-index -q --refresh
bc9e7399
JH
167 if no_changes
168 then
fcdd0e92 169 say 'No local changes to save'
bc9e7399
JH
170 exit 0
171 fi
172 test -f "$GIT_DIR/logs/$ref_stash" ||
173 clear_stash || die "Cannot initialize stash"
174
175 create_stash "$stash_msg"
a9ee9bf9
EM
176
177 # Make sure the reflog for stash is kept.
178 : >>"$GIT_DIR/logs/$ref_stash"
f2c66ed1 179
9f62e18a 180 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
f2c66ed1 181 die "Cannot save the current status"
fcdd0e92 182 say Saved working directory and index state "$stash_msg"
7bedebca 183
dda1f2a5 184 if test -z "$patch_mode"
7bedebca 185 then
dda1f2a5
TR
186 git reset --hard ${GIT_QUIET:+-q}
187
188 if test -n "$keep_index" && test -n $i_tree
189 then
190 git read-tree --reset -u $i_tree
191 fi
192 else
193 git apply -R < "$TMP-patch" ||
194 die "Cannot remove worktree changes"
195
196 if test -z "$keep_index"
197 then
198 git reset
199 fi
7bedebca 200 fi
f2c66ed1
NS
201}
202
401de405 203have_stash () {
0e32126f 204 git rev-parse --verify $ref_stash >/dev/null 2>&1
401de405
JK
205}
206
f2c66ed1 207list_stash () {
401de405 208 have_stash || return 0
391c53bd 209 git log --format="%gd: %gs" -g "$@" $ref_stash --
f2c66ed1
NS
210}
211
212show_stash () {
a9bf09e1 213 assert_stash_like "$@"
14cd4581 214
a9bf09e1 215 git diff ${FLAGS:---stat} $b_commit $w_commit
f2c66ed1
NS
216}
217
ef763129
JS
218#
219# Parses the remaining options looking for flags and
220# at most one revision defaulting to ${ref_stash}@{0}
221# if none found.
222#
223# Derives related tree and commit objects from the
224# revision, if one is found.
225#
226# stash records the work tree, and is a merge between the
227# base commit (first parent) and the index tree (second parent).
228#
229# REV is set to the symbolic version of the specified stash-like commit
230# IS_STASH_LIKE is non-blank if ${REV} looks like a stash
231# IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
232# s is set to the SHA1 of the stash commit
233# w_commit is set to the commit containing the working tree
234# b_commit is set to the base commit
235# i_commit is set to the commit containing the index tree
236# w_tree is set to the working tree
237# b_tree is set to the base tree
238# i_tree is set to the index tree
239#
240# GIT_QUIET is set to t if -q is specified
241# INDEX_OPTION is set to --index if --index is specified.
242# FLAGS is set to the remaining flags
243#
244# dies if:
245# * too many revisions specified
246# * no revision is specified and there is no stash stack
247# * a revision is specified which cannot be resolve to a SHA1
248# * a non-existent stash reference is specified
249#
250
251parse_flags_and_rev()
252{
253 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
254 PARSE_CACHE="$*"
255
256 IS_STASH_LIKE=
257 IS_STASH_REF=
258 INDEX_OPTION=
259 s=
260 w_commit=
261 b_commit=
262 i_commit=
263 w_tree=
264 b_tree=
265 i_tree=
266
267 REV=$(git rev-parse --no-flags --symbolic "$@" 2>/dev/null)
268 FLAGS=$(git rev-parse --no-revs -- "$@" 2>/dev/null)
269
270 set -- $FLAGS
271
272 FLAGS=
273 while test $# -ne 0
274 do
275 case "$1" in
276 -q|--quiet)
277 GIT_QUIET=-t
278 ;;
279 --index)
280 INDEX_OPTION=--index
281 ;;
282 --)
283 :
284 ;;
285 *)
286 FLAGS="${FLAGS}${FLAGS:+ }$1"
287 ;;
288 esac
289 shift
290 done
291
292 set -- $REV
293
294 case $# in
295 0)
296 have_stash || die "No stash found."
297 set -- ${ref_stash}@{0}
298 ;;
299 1)
300 :
301 ;;
302 *)
303 die "Too many revisions specified: $REV"
304 ;;
305 esac
306
307 REV=$(git rev-parse --quiet --symbolic --verify $1 2>/dev/null) || die "$1 is not valid reference"
308
309 i_commit=$(git rev-parse --quiet --verify $REV^2 2>/dev/null) &&
310 set -- $(git rev-parse $REV $REV^1 $REV: $REV^1: $REV^2: 2>/dev/null) &&
311 s=$1 &&
312 w_commit=$1 &&
313 b_commit=$2 &&
314 w_tree=$3 &&
315 b_tree=$4 &&
316 i_tree=$5 &&
317 IS_STASH_LIKE=t &&
318 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
319 IS_STASH_REF=t
320
b0f0ecd9
JS
321 if test "${REV}" != "${REV%{*\}}"
322 then
323 # maintainers: it would be better if git rev-parse indicated
324 # this condition with a non-zero status code but as of 1.7.2.1 it
325 # it did not. So, we use non-empty stderr output as a proxy for the
326 # condition of interest.
327 test -z "$(git rev-parse "$REV" 2>&1 >/dev/null)" || die "$REV does not exist in the stash log"
328 fi
329
ef763129
JS
330}
331
332is_stash_like()
333{
334 parse_flags_and_rev "$@"
335 test -n "$IS_STASH_LIKE"
336}
337
338assert_stash_like() {
339 is_stash_like "$@" || die "'$*' is not a stash-like commit"
340}
341
342is_stash_ref() {
343 is_stash_like "$@" && test -n "$IS_STASH_REF"
344}
345
346assert_stash_ref() {
347 is_stash_ref "$@" || die "'$*' is not a stash reference"
348}
349
f2c66ed1 350apply_stash () {
fcdd0e92 351
064ed100 352 assert_stash_like "$@"
f2c66ed1 353
5fd448f1
OA
354 git update-index -q --refresh &&
355 git diff-files --quiet --ignore-submodules ||
356 die 'Cannot apply to a dirty working tree, please stage your changes'
357
358 # current index state
359 c_tree=$(git write-tree) ||
360 die 'Cannot apply a stash in the middle of a merge'
361
cbeaccc3 362 unstashed_index_tree=
064ed100 363 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
7bedebca 364 test "$c_tree" != "$i_tree"
cbeaccc3 365 then
89d750bf 366 git diff-tree --binary $s^2^..$s^2 | git apply --cached
150937c4
JS
367 test $? -ne 0 &&
368 die 'Conflicts in index. Try without --index.'
52070790 369 unstashed_index_tree=$(git write-tree) ||
150937c4
JS
370 die 'Could not save index tree'
371 git reset
cbeaccc3 372 fi
150937c4 373
f2c66ed1
NS
374 eval "
375 GITHEAD_$w_tree='Stashed changes' &&
376 GITHEAD_$c_tree='Updated upstream' &&
377 GITHEAD_$b_tree='Version stash was based on' &&
378 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
379 "
380
fcdd0e92
SB
381 if test -n "$GIT_QUIET"
382 then
383 export GIT_MERGE_VERBOSITY=0
384 fi
52070790 385 if git merge-recursive $b_tree -- $c_tree $w_tree
f2c66ed1
NS
386 then
387 # No conflict
cbeaccc3
JH
388 if test -n "$unstashed_index_tree"
389 then
390 git read-tree "$unstashed_index_tree"
83b3df7d
JH
391 else
392 a="$TMP-added" &&
89d750bf 393 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
83b3df7d
JH
394 git read-tree --reset $c_tree &&
395 git update-index --add --stdin <"$a" ||
396 die "Cannot unstage modified files"
397 rm -f "$a"
cbeaccc3 398 fi
fcdd0e92
SB
399 squelch=
400 if test -n "$GIT_QUIET"
401 then
402 squelch='>/dev/null 2>&1'
403 fi
404 eval "git status $squelch" || :
f2c66ed1
NS
405 else
406 # Merge conflict; keep the exit status from merge-recursive
150937c4 407 status=$?
064ed100 408 if test -n "$INDEX_OPTION"
cbeaccc3
JH
409 then
410 echo >&2 'Index was not unstashed.'
411 fi
150937c4 412 exit $status
f2c66ed1
NS
413 fi
414}
415
f276872d
JS
416pop_stash() {
417 assert_stash_ref "$@"
418
419 apply_stash "$@" &&
420 drop_stash "$@"
421}
422
e25d5f9c 423drop_stash () {
92e39e44 424 assert_stash_ref "$@"
e25d5f9c 425
92e39e44
JS
426 git reflog delete --updateref --rewrite "${REV}" &&
427 say "Dropped ${REV} ($s)" || die "${REV}: Could not drop stash entry"
e25d5f9c
BC
428
429 # clear_stash if we just dropped the last stash entry
0e32126f 430 git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
e25d5f9c
BC
431}
432
656b5034 433apply_to_branch () {
656b5034
AMS
434 test -n "$1" || die 'No branch name specified'
435 branch=$1
fb433dc9 436 shift 1
656b5034 437
fb433dc9
JS
438 set -- --index "$@"
439 assert_stash_like "$@"
440
441 git checkout -b $branch $REV^ &&
442 apply_stash "$@"
656b5034 443
fb433dc9 444 test -z "$IS_STASH_REF" || drop_stash "$@"
656b5034
AMS
445}
446
ef763129 447PARSE_CACHE='--not-parsed'
3c2eb80f
MM
448# The default command is "save" if nothing but options are given
449seen_non_option=
450for opt
451do
452 case "$opt" in
453 -*) ;;
454 *) seen_non_option=t; break ;;
455 esac
456done
457
458test -n "$seen_non_option" || set "save" "$@"
459
f2c66ed1
NS
460# Main command set
461case "$1" in
fcb10a96
JH
462list)
463 shift
f2c66ed1
NS
464 list_stash "$@"
465 ;;
466show)
467 shift
468 show_stash "$@"
469 ;;
683befa1
KL
470save)
471 shift
47629dcf 472 save_stash "$@"
683befa1 473 ;;
f2c66ed1
NS
474apply)
475 shift
476 apply_stash "$@"
477 ;;
478clear)
3023dc69
JH
479 shift
480 clear_stash "$@"
f2c66ed1 481 ;;
bc9e7399
JH
482create)
483 if test $# -gt 0 && test "$1" = create
484 then
485 shift
486 fi
487 create_stash "$*" && echo "$w_commit"
488 ;;
e25d5f9c
BC
489drop)
490 shift
491 drop_stash "$@"
492 ;;
bd56ff54
BC
493pop)
494 shift
f276872d 495 pop_stash "$@"
bd56ff54 496 ;;
656b5034
AMS
497branch)
498 shift
499 apply_to_branch "$@"
500 ;;
f2c66ed1 501*)
3c2eb80f
MM
502 case $# in
503 0)
97bc00a4 504 save_stash &&
fcdd0e92 505 say '(To restore them type "git stash apply")'
ea41cfc4
JS
506 ;;
507 *)
683befa1 508 usage
ea41cfc4 509 esac
9f62e18a 510 ;;
f2c66ed1 511esac